Hdfs (Apache Hadoop HDFS Client 3.5.0 API)
Description: declaration: package: org.apache.hadoop.fs, class: Hdfs

Package org.apache.hadoop.fs

# Class Hdfs

java.lang.Object
org.apache.hadoop.fs.AbstractFileSystem
org.apache.hadoop.fs.Hdfs

All Implemented Interfaces:
  `org.apache.hadoop.fs.PathCapabilities`

@Private @Evolving public class Hdfs extends org.apache.hadoop.fs.AbstractFileSystem

- ## Field Summary

  ### Fields inherited from class org.apache.hadoop.fs.AbstractFileSystem

  `statistics`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `access(org.apache.hadoop.fs.Path path, org.apache.hadoop.fs.permission.FsAction mode)`
  `void`
  `cancelDelegationToken(org.apache.hadoop.security.token.Token<? extends org.apache.hadoop.security.token.delegation.AbstractDelegationTokenIdentifier> token)`
  Deprecated.
  Use Token.cancel instead.
  `HdfsDataOutputStream`
  `createInternal(org.apache.hadoop.fs.Path f, EnumSet<org.apache.hadoop.fs.CreateFlag> createFlag, org.apache.hadoop.fs.permission.FsPermission absolutePermission, int bufferSize, short replication, long blockSize, org.apache.hadoop.util.Progressable progress, org.apache.hadoop.fs.Options.ChecksumOpt checksumOpt, boolean createParent)`
  `org.apache.hadoop.fs.Path`
  `createSnapshot(org.apache.hadoop.fs.Path path, String snapshotName)`
  `void`
  `createSymlink(org.apache.hadoop.fs.Path target, org.apache.hadoop.fs.Path link, boolean createParent)`
  `boolean`
  `delete(org.apache.hadoop.fs.Path f, boolean recursive)`
  `void`
  `deleteSnapshot(org.apache.hadoop.fs.Path snapshotDir, String snapshotName)`
  `org.apache.hadoop.fs.permission.AclStatus`
  `getAclStatus(org.apache.hadoop.fs.Path path)`
  `Collection<? extends org.apache.hadoop.fs.BlockStoragePolicySpi>`
  `getAllStoragePolicies()`
  `String`
  `getCanonicalServiceName()`
  `List<org.apache.hadoop.security.token.Token<?>>`
  `getDelegationTokens(String renewer)`
  `org.apache.hadoop.fs.BlockLocation[]`
  `getFileBlockLocations(org.apache.hadoop.fs.Path p, long start, long len)`
  The returned BlockLocation will have different formats for replicated and erasure coded file.
  `org.apache.hadoop.fs.FileChecksum`
  `getFileChecksum(org.apache.hadoop.fs.Path f)`
  `org.apache.hadoop.fs.FileStatus`
  `getFileLinkStatus(org.apache.hadoop.fs.Path f)`
  `org.apache.hadoop.fs.FileStatus`
  `getFileStatus(org.apache.hadoop.fs.Path f)`
  If the given path is a symlink, the path will be resolved to a target path and it will get the resolved path's FileStatus object.
  `org.apache.hadoop.fs.FsStatus`
  `getFsStatus()`
  `org.apache.hadoop.fs.Path`
  `getLinkTarget(org.apache.hadoop.fs.Path p)`
  `org.apache.hadoop.fs.FsServerDefaults`
  `getServerDefaults()`
  Deprecated.
  `org.apache.hadoop.fs.FsServerDefaults`
  `getServerDefaults(org.apache.hadoop.fs.Path f)`
  `org.apache.hadoop.fs.BlockStoragePolicySpi`
  `getStoragePolicy(org.apache.hadoop.fs.Path src)`
  `int`
  `getUriDefaultPort()`
  `byte[]`
  `getXAttr(org.apache.hadoop.fs.Path path, String name)`
  `Map<String,byte[]>`
  `getXAttrs(org.apache.hadoop.fs.Path path)`
  `Map<String,byte[]>`
  `getXAttrs(org.apache.hadoop.fs.Path path, List<String> names)`
  `org.apache.hadoop.fs.RemoteIterator<org.apache.hadoop.fs.Path>`
  `listCorruptFileBlocks(org.apache.hadoop.fs.Path path)`
  `org.apache.hadoop.fs.RemoteIterator<org.apache.hadoop.fs.LocatedFileStatus>`
  `listLocatedStatus(org.apache.hadoop.fs.Path p)`
  The BlockLocation of returned LocatedFileStatus will have different formats for replicated and erasure coded file.
  `org.apache.hadoop.fs.FileStatus[]`
  `listStatus(org.apache.hadoop.fs.Path f)`
  If any of the the immediate children of the given path f is a symlink, the returned FileStatus object of that children would be represented as a symlink.
  `org.apache.hadoop.fs.RemoteIterator<org.apache.hadoop.fs.FileStatus>`
  `listStatusIterator(org.apache.hadoop.fs.Path f)`
  `List<String>`
  `listXAttrs(org.apache.hadoop.fs.Path path)`
  `void`
  `mkdir(org.apache.hadoop.fs.Path dir, org.apache.hadoop.fs.permission.FsPermission permission, boolean createParent)`
  `void`
  `modifyAclEntries(org.apache.hadoop.fs.Path path, List<org.apache.hadoop.fs.permission.AclEntry> aclSpec)`
  `void`
  `msync()`
  Synchronize client metadata state with Active NameNode.
  `HdfsDataInputStream`
  `open(org.apache.hadoop.fs.Path f, int bufferSize)`
  `void`
  `removeAcl(org.apache.hadoop.fs.Path path)`
  `void`
  `removeAclEntries(org.apache.hadoop.fs.Path path, List<org.apache.hadoop.fs.permission.AclEntry> aclSpec)`
  `void`
  `removeDefaultAcl(org.apache.hadoop.fs.Path path)`
  `void`
  `removeXAttr(org.apache.hadoop.fs.Path path, String name)`
  `void`
  `renameInternal(org.apache.hadoop.fs.Path src, org.apache.hadoop.fs.Path dst)`
  `void`
  `renameInternal(org.apache.hadoop.fs.Path src, org.apache.hadoop.fs.Path dst, boolean overwrite)`
  `void`
  `renameSnapshot(org.apache.hadoop.fs.Path path, String snapshotOldName, String snapshotNewName)`
  `long`
  `renewDelegationToken(org.apache.hadoop.security.token.Token<? extends org.apache.hadoop.security.token.delegation.AbstractDelegationTokenIdentifier> token)`
  Deprecated.
  Use Token.renew instead.
  `void`
  `satisfyStoragePolicy(org.apache.hadoop.fs.Path path)`
  `void`
  `setAcl(org.apache.hadoop.fs.Path path, List<org.apache.hadoop.fs.permission.AclEntry> aclSpec)`
  `void`
  `setOwner(org.apache.hadoop.fs.Path f, String username, String groupname)`
  `void`
  `setPermission(org.apache.hadoop.fs.Path f, org.apache.hadoop.fs.permission.FsPermission permission)`
  `boolean`
  `setReplication(org.apache.hadoop.fs.Path f, short replication)`
  `void`
  `setStoragePolicy(org.apache.hadoop.fs.Path path, String policyName)`
  `void`
  `setTimes(org.apache.hadoop.fs.Path f, long mtime, long atime)`
  `void`
  `setVerifyChecksum(boolean verifyChecksum)`
  `void`
  `setXAttr(org.apache.hadoop.fs.Path path, String name, byte[] value, EnumSet<org.apache.hadoop.fs.XAttrSetFlag> flag)`
  `boolean`
  `supportsSymlinks()`
  `boolean`
  `truncate(org.apache.hadoop.fs.Path f, long newLength)`
  `void`
  `unsetStoragePolicy(org.apache.hadoop.fs.Path src)`

  ### Methods inherited from class org.apache.hadoop.fs.AbstractFileSystem

  `checkPath, checkScheme, clearStatistics, create, createFileSystem, createMultipartUploader, equals, get, getAllStatistics, getEnclosingRoot, getFsStatus, getHomeDirectory, getInitialWorkingDirectory, getStatistics, getStatistics, getUri, getUriPath, hashCode, hasPathCapability, isValidName, makeQualified, methodNotSupported, open, openFileWithOptions, printStatistics, rename, resolvePath, setXAttr`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### getUriDefaultPort

    public int getUriDefaultPort()
    Specified by:
      `getUriDefaultPort` in class `org.apache.hadoop.fs.AbstractFileSystem`

  - ### createInternal

    public HdfsDataOutputStream createInternal(org.apache.hadoop.fs.Path f, EnumSet<org.apache.hadoop.fs.CreateFlag> createFlag, org.apache.hadoop.fs.permission.FsPermission absolutePermission, int bufferSize, short replication, long blockSize, org.apache.hadoop.util.Progressable progress, org.apache.hadoop.fs.Options.ChecksumOpt checksumOpt, boolean createParent) throws IOException
    Specified by:
      `createInternal` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### delete

    public boolean delete(org.apache.hadoop.fs.Path f, boolean recursive) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    Specified by:
      `delete` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### getFileBlockLocations

    public org.apache.hadoop.fs.BlockLocation[] getFileBlockLocations(org.apache.hadoop.fs.Path p, long start, long len) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    The returned BlockLocation will have different formats for replicated and erasure coded file. Please refer to `FileContext.getFileBlockLocations(Path, long, long)` for more details.
    Specified by:
      `getFileBlockLocations` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### getFileChecksum

    public org.apache.hadoop.fs.FileChecksum getFileChecksum(org.apache.hadoop.fs.Path f) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    Specified by:
      `getFileChecksum` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### getFileStatus

    public org.apache.hadoop.fs.FileStatus getFileStatus(org.apache.hadoop.fs.Path f) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    If the given path is a symlink, the path will be resolved to a target path and it will get the resolved path's FileStatus object. It will not be represented as a symlink and isDirectory API returns true if the resolved path is a directory, false otherwise.
    Specified by:
      `getFileStatus` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### msync

    public void msync() throws IOException
    Synchronize client metadata state with Active NameNode.

    In HA the client synchronizes its state with the Active NameNode in order to guarantee subsequent read consistency from Observer Nodes.

    Overrides:
      `msync` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### getFileLinkStatus

    public org.apache.hadoop.fs.FileStatus getFileLinkStatus(org.apache.hadoop.fs.Path f) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    Overrides:
      `getFileLinkStatus` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### getFsStatus

    public org.apache.hadoop.fs.FsStatus getFsStatus() throws IOException
    Specified by:
      `getFsStatus` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### getServerDefaults

    @Deprecated public org.apache.hadoop.fs.FsServerDefaults getServerDefaults() throws IOException
    Deprecated.
    Specified by:
      `getServerDefaults` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### getServerDefaults

    public org.apache.hadoop.fs.FsServerDefaults getServerDefaults(org.apache.hadoop.fs.Path f) throws IOException
    Overrides:
      `getServerDefaults` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### listLocatedStatus

    public org.apache.hadoop.fs.RemoteIterator<org.apache.hadoop.fs.LocatedFileStatus> listLocatedStatus(org.apache.hadoop.fs.Path p) throws FileNotFoundException, IOException
    The BlockLocation of returned LocatedFileStatus will have different formats for replicated and erasure coded file. Please refer to `FileContext.getFileBlockLocations(Path, long, long)` for more details.
    Overrides:
      `listLocatedStatus` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `FileNotFoundException`
      `IOException`

  - ### listStatusIterator

    public org.apache.hadoop.fs.RemoteIterator<org.apache.hadoop.fs.FileStatus> listStatusIterator(org.apache.hadoop.fs.Path f) throws org.apache.hadoop.security.AccessControlException, FileNotFoundException, org.apache.hadoop.fs.UnresolvedLinkException, IOException
    Overrides:
      `listStatusIterator` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `org.apache.hadoop.security.AccessControlException`
      `FileNotFoundException`
      `org.apache.hadoop.fs.UnresolvedLinkException`
      `IOException`

  - ### listStatus

    public org.apache.hadoop.fs.FileStatus[] listStatus(org.apache.hadoop.fs.Path f) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    If any of the the immediate children of the given path f is a symlink, the returned FileStatus object of that children would be represented as a symlink. It will not be resolved to the target path and will not get the target path FileStatus object. The target path will be available via getSymlink on that children's FileStatus object. Since it represents as symlink, isDirectory on that children's FileStatus will return false. If you want to get the FileStatus of target path for that children, you may want to use GetFileStatus API with that children's symlink path. Please see `getFileStatus(Path f)`
    Specified by:
      `listStatus` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### listCorruptFileBlocks

    public org.apache.hadoop.fs.RemoteIterator<org.apache.hadoop.fs.Path> listCorruptFileBlocks(org.apache.hadoop.fs.Path path) throws IOException
    Overrides:
      `listCorruptFileBlocks` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### mkdir

    public void mkdir(org.apache.hadoop.fs.Path dir, org.apache.hadoop.fs.permission.FsPermission permission, boolean createParent) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    Specified by:
      `mkdir` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### open

    public HdfsDataInputStream open(org.apache.hadoop.fs.Path f, int bufferSize) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    Specified by:
      `open` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### truncate

    public boolean truncate(org.apache.hadoop.fs.Path f, long newLength) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    Overrides:
      `truncate` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### renameInternal

    public void renameInternal(org.apache.hadoop.fs.Path src, org.apache.hadoop.fs.Path dst) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    Specified by:
      `renameInternal` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### renameInternal

    public void renameInternal(org.apache.hadoop.fs.Path src, org.apache.hadoop.fs.Path dst, boolean overwrite) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    Overrides:
      `renameInternal` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### setOwner

    public void setOwner(org.apache.hadoop.fs.Path f, String username, String groupname) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    Specified by:
      `setOwner` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### setPermission

    public void setPermission(org.apache.hadoop.fs.Path f, org.apache.hadoop.fs.permission.FsPermission permission) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    Specified by:
      `setPermission` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### setReplication

    public boolean setReplication(org.apache.hadoop.fs.Path f, short replication) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    Specified by:
      `setReplication` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### setTimes

    public void setTimes(org.apache.hadoop.fs.Path f, long mtime, long atime) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    Specified by:
      `setTimes` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### setVerifyChecksum

    public void setVerifyChecksum(boolean verifyChecksum) throws IOException
    Specified by:
      `setVerifyChecksum` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### supportsSymlinks

    public boolean supportsSymlinks()
    Overrides:
      `supportsSymlinks` in class `org.apache.hadoop.fs.AbstractFileSystem`

  - ### createSymlink

    public void createSymlink(org.apache.hadoop.fs.Path target, org.apache.hadoop.fs.Path link, boolean createParent) throws IOException, org.apache.hadoop.fs.UnresolvedLinkException
    Overrides:
      `createSymlink` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`
      `org.apache.hadoop.fs.UnresolvedLinkException`

  - ### getLinkTarget

    public org.apache.hadoop.fs.Path getLinkTarget(org.apache.hadoop.fs.Path p) throws IOException
    Overrides:
      `getLinkTarget` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### getCanonicalServiceName

    public String getCanonicalServiceName()
    Overrides:
      `getCanonicalServiceName` in class `org.apache.hadoop.fs.AbstractFileSystem`

  - ### getDelegationTokens

    public List<org.apache.hadoop.security.token.Token<?>> getDelegationTokens(String renewer) throws IOException
    Overrides:
      `getDelegationTokens` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### modifyAclEntries

    public void modifyAclEntries(org.apache.hadoop.fs.Path path, List<org.apache.hadoop.fs.permission.AclEntry> aclSpec) throws IOException
    Overrides:
      `modifyAclEntries` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### removeAclEntries

    public void removeAclEntries(org.apache.hadoop.fs.Path path, List<org.apache.hadoop.fs.permission.AclEntry> aclSpec) throws IOException
    Overrides:
      `removeAclEntries` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### removeDefaultAcl

    public void removeDefaultAcl(org.apache.hadoop.fs.Path path) throws IOException
    Overrides:
      `removeDefaultAcl` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### removeAcl

    public void removeAcl(org.apache.hadoop.fs.Path path) throws IOException
    Overrides:
      `removeAcl` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### setAcl

    public void setAcl(org.apache.hadoop.fs.Path path, List<org.apache.hadoop.fs.permission.AclEntry> aclSpec) throws IOException
    Overrides:
      `setAcl` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### getAclStatus

    public org.apache.hadoop.fs.permission.AclStatus getAclStatus(org.apache.hadoop.fs.Path path) throws IOException
    Overrides:
      `getAclStatus` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### setXAttr

    public void setXAttr(org.apache.hadoop.fs.Path path, String name, byte[] value, EnumSet<org.apache.hadoop.fs.XAttrSetFlag> flag) throws IOException
    Overrides:
      `setXAttr` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### getXAttr

    public byte[] getXAttr(org.apache.hadoop.fs.Path path, String name) throws IOException
    Overrides:
      `getXAttr` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### getXAttrs

    public Map<String,byte[]> getXAttrs(org.apache.hadoop.fs.Path path) throws IOException
    Overrides:
      `getXAttrs` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### getXAttrs

    public Map<String,byte[]> getXAttrs(org.apache.hadoop.fs.Path path, List<String> names) throws IOException
    Overrides:
      `getXAttrs` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### listXAttrs

    public List<String> listXAttrs(org.apache.hadoop.fs.Path path) throws IOException
    Overrides:
      `listXAttrs` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### removeXAttr

    public void removeXAttr(org.apache.hadoop.fs.Path path, String name) throws IOException
    Overrides:
      `removeXAttr` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### access

    public void access(org.apache.hadoop.fs.Path path, org.apache.hadoop.fs.permission.FsAction mode) throws IOException
    Overrides:
      `access` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### satisfyStoragePolicy

    public void satisfyStoragePolicy(org.apache.hadoop.fs.Path path) throws IOException
    Overrides:
      `satisfyStoragePolicy` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### setStoragePolicy

    public void setStoragePolicy(org.apache.hadoop.fs.Path path, String policyName) throws IOException
    Overrides:
      `setStoragePolicy` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### unsetStoragePolicy

    public void unsetStoragePolicy(org.apache.hadoop.fs.Path src) throws IOException
    Overrides:
      `unsetStoragePolicy` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### getStoragePolicy

    public org.apache.hadoop.fs.BlockStoragePolicySpi getStoragePolicy(org.apache.hadoop.fs.Path src) throws IOException
    Overrides:
      `getStoragePolicy` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### getAllStoragePolicies

    public Collection<? extends org.apache.hadoop.fs.BlockStoragePolicySpi> getAllStoragePolicies() throws IOException
    Overrides:
      `getAllStoragePolicies` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### renewDelegationToken

    public long renewDelegationToken(org.apache.hadoop.security.token.Token<? extends org.apache.hadoop.security.token.delegation.AbstractDelegationTokenIdentifier> token) throws org.apache.hadoop.security.token.SecretManager.InvalidToken, IOException
    Deprecated.
    Use Token.renew instead.
    Renew an existing delegation token.
    Parameters:
      `token` - delegation token obtained earlier
    Returns:
      the new expiration time
    Throws:
      `org.apache.hadoop.security.token.SecretManager.InvalidToken`
      `IOException`

  - ### cancelDelegationToken

    public void cancelDelegationToken(org.apache.hadoop.security.token.Token<? extends org.apache.hadoop.security.token.delegation.AbstractDelegationTokenIdentifier> token) throws org.apache.hadoop.security.token.SecretManager.InvalidToken, IOException
    Deprecated.
    Use Token.cancel instead.
    Cancel an existing delegation token.
    Parameters:
      `token` - delegation token
    Throws:
      `org.apache.hadoop.security.token.SecretManager.InvalidToken`
      `IOException`

  - ### createSnapshot

    public org.apache.hadoop.fs.Path createSnapshot(org.apache.hadoop.fs.Path path, String snapshotName) throws IOException
    Overrides:
      `createSnapshot` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### renameSnapshot

    public void renameSnapshot(org.apache.hadoop.fs.Path path, String snapshotOldName, String snapshotNewName) throws IOException
    Overrides:
      `renameSnapshot` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`

  - ### deleteSnapshot

    public void deleteSnapshot(org.apache.hadoop.fs.Path snapshotDir, String snapshotName) throws IOException
    Overrides:
      `deleteSnapshot` in class `org.apache.hadoop.fs.AbstractFileSystem`
    Throws:
      `IOException`